from fractions import gcd

T = int(input())
for t in range(T):
    input()
    N = int(input())

    data = [ input() for n in range(N) ]
    X, Y, R = [ [ int(x.split()[i]) for x in data ] for i in range(3) ]

    clockwise = [ None for n in range(N) ]
    clockwise[0] = True
    jammed = False

    # instead of DFS/BFS, just iterate over all wheels N times
    for phase in range(N):
        for a in range(N):
            if clockwise[a] is None: continue
            for b in range(N):
                if a == b: continue
                if (X[a]-X[b])**2 + (Y[a]-Y[b])**2 > (R[a]+R[b])**2: continue
                if clockwise[b] is None:
                    clockwise[b] = not clockwise[a]
                    continue
                if clockwise[a] == clockwise[b]:
                    jammed = True

    if jammed or (clockwise[N-1] is None):
        print('does not rotate')
    else:
        d = gcd(R[0],R[N-1])
        print('{}/{} {}'.format(R[0]//d,R[N-1]//d,'clockwise' if clockwise[N-1] else 'counterclockwise'))
